#ifndef UTILCLASS_H
#define UTILCLASS_H
#include <bits/stdc++.h>
#define residueSize 26
using namespace std;

/*const double m_m = -log(0.97668000), i_i = -log(0.60350500), m_i = -log(0.30207600); 
const double i_m = -log(0.01166000), d_m = -log(0.01166000), d_i = -log(0.09441900); 
const double m_d = -log(0.30207600), i_d = -log(0.09441900), d_d = -log(0.60350500);*/

const double sum_m = 0.98191 + 0.00905 + 0.00905;
const double sum_i = 0.29710 + 0.70132 + 0.00158;
const double sum_d = sum_i;

/*const double m_m = -log(0.98191/sum_m), i_i = -log(0.70132/sum_i), m_i = -log(0.00905/sum_m);
const double i_m = -log(0.29710/sum_i), d_m = -log(0.29710/sum_d), d_i = -log(0.00158/sum_d);
const double m_d = -log(0.00905/sum_m), i_d = -log(0.00158/sum_i), d_d = -log(0.70132/sum_d);*/

const double m_m = -log(0.98191/sum_m);
const double i_m = -log(0.00905/sum_m);
const double d_m = -log(0.00905/sum_m);

const double m_i = -log(0.29710/sum_i);
const double i_i = -log(0.70132/sum_i);
const double d_i = -log(0.00158/sum_i);

const double m_d = -log(0.29710/sum_d);
const double i_d = -log(0.00158/sum_d);
const double d_d = -log(0.70132/sum_d);

const string non_AA_codes = "BJOUXZ";
const string AA_codes = "ARNDCQEGHILKMFPSTWYV";


void file_write(string&, vector<string>&);
void file_append(const string&, const string&);
vector<string> file_read(const string&);
string num2str(const double, unsigned int, unsigned int);
int catalan(int n);
double encodeWTBits(int n);
double encodeWTNits(int n);
double encodeLogStarBits(size_t n);
double encodeLogStarNits(size_t n);
double nits2bits(double x);
double bits2nits(double x);
void init(string, string, vector<double>&, vector<double>&);
void mmlProbVector(string&, vector<double>&);
void condProbVector(string&, vector<double>&);
double mmlEstimate(const string&, vector<double>&);
double mmlEstimateAA(const char&, vector<double>&);
double conditEstimate(const string&, const string&, vector<double>&);
double conditEstimateAA(const char&, const char&, vector<double>&);
void find_non_AA_characters(string&);
void read_fasta_file(const string&, bool, vector<string>&, const int&, const int&, int&, int&);
string readSource(const string&, const bool&, vector<string>&, const int&, const int&);
vector<string> split(const string&, const char);
double findMin(const double&, const double&, const double&);
#endif